/*
		JumpToShop.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Class for dialog of same name
*/

#include "stdafx.h"
#include "Cbreak.h"
#include "JumpToShop.h"
#include "Sedit.h"
#include "World.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// JumpToShop dialog


JumpToShop::JumpToShop(CWnd* pParent /*=NULL*/)
	: CDialog(JumpToShop::IDD, pParent)
{
	//{{AFX_DATA_INIT(JumpToShop)
	m_jump_string = _T("");
	m_new_shop = 0;
	//}}AFX_DATA_INIT
}


void JumpToShop::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(JumpToShop)
	DDX_Text(pDX, IDC_JUMP_WARNING, m_jump_string);
	DDX_Text(pDX, IDC_NEW_SHOP, m_new_shop);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(JumpToShop, CDialog)
	//{{AFX_MSG_MAP(JumpToShop)
	ON_EN_CHANGE(IDC_NEW_SHOP, OnChangeNewShop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// JumpToShop message handlers

void JumpToShop::OnOK() 
{
  extern CCbreakApp theApp;
	extern World the_world;
  map<int,Shop>::const_iterator ri;

	if(m_new_shop > 32699 || m_new_shop < 0) {
	  m_jump_string = "Out of Range";
		UpdateData(FALSE);
		return;
	}

	ri = the_world.shop_list.find(m_new_shop);
	if(ri==the_world.shop_list.end()) {
		m_jump_string = "That shop DNE";
		UpdateData(FALSE);
		return;
	}

	theApp.dlg->current_shop = m_new_shop;
	
	theApp.dlg->m_sedit.LoadSedit();

	CDialog::OnOK();
}

void JumpToShop::OnChangeNewShop() 
{
  UpdateData(TRUE);	
}

BOOL JumpToShop::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	GetDlgItem(IDC_NEW_SHOP)->SetFocus();
	
	return TRUE; 
}
